"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const FS = require("fs");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
const devKitCore = require("@angular-devkit/core");
const build_ng_packagr_1 = require("@angular-devkit/build-ng-packagr");
const ngPackagr = require("ng-packagr");
// TODO: Remove when issue is fixed.
require("./workaround-issue-1189");
const create_hook_provider_1 = require("./create-hook-provider");
const utils_1 = require("./utils");
const hook_registry_1 = require("./hook-registry");
__export(require("./hook-registry"));
var job_1 = require("./job");
exports.Job = job_1.Job;
var utils_2 = require("./utils");
exports.ENTRY_POINT_STORAGE = utils_2.ENTRY_POINT_STORAGE;
const DEFAULT_TSCONFIG_OPTIONS = {
    moduleResolution: 'node',
    module: 'commonjs',
    target: 'es6',
    lib: [
        'es2017',
        'dom'
    ],
};
// Instead of re-writing NgPackagrBuilder in full, just for adding some providers, we will patch
// the NgPackager instead... ohh my!
class NgPackagrBuilder extends build_ng_packagr_1.NgPackagrBuilder {
    run(builderConfig) {
        const builderContext = this.context;
        this.options = builderConfig.options;
        const root = this.context.workspace.root;
        const { tasks } = this.options;
        const { build, watch } = ngPackagr.NgPackagr.prototype;
        const globalTasksContext = {
            logger: this.context.logger,
            root,
            builderContext,
            builderConfig
        };
        return rxjs_1.from(this.buildRegistry(tasks.config, globalTasksContext))
            .pipe(operators_1.switchMap(registry => utils_1.validateTypedTasks(registry.getJobs(), this.context, tasks).then(() => registry)), operators_1.tap(registry => {
            const providers = create_hook_provider_1.createHookProviders(registry.getHooks(), globalTasksContext);
            ngPackagr.NgPackagr.prototype.build = function () {
                this.withProviders(providers);
                return build.call(this);
            };
            ngPackagr.NgPackagr.prototype.watch = function () {
                this.withProviders(providers);
                if (registry.hasSelfWatchJob) {
                    return this.buildAsObservable();
                }
                else {
                    return watch.call(this);
                }
            };
        }), operators_1.switchMap(() => super.run(builderConfig)), operators_1.tap(buildEvent => {
            ngPackagr.NgPackagr.prototype.build = build;
            ngPackagr.NgPackagr.prototype.watch = watch;
        }));
    }
    buildRegistry(transformerPath, globalTasksContext) {
        return __awaiter(this, void 0, void 0, function* () {
            const { tasks } = this.options;
            const root = this.context.workspace.root;
            const tPath = devKitCore.getSystemPath(devKitCore.resolve(root, devKitCore.normalize(transformerPath)));
            if (FS.existsSync(tPath)) {
                if (/\.ts$/.test(tPath) && !require.extensions['.ts']) {
                    const tsNodeOptions = {};
                    if (tasks.tsConfig) {
                        tsNodeOptions.project = tasks.tsConfig;
                    }
                    else {
                        tsNodeOptions.compilerOptions = DEFAULT_TSCONFIG_OPTIONS;
                    }
                    require('ts-node').register(tsNodeOptions);
                }
                const transformHooksModule = require(tPath);
                if (typeof transformHooksModule === 'function') {
                    const registry = new hook_registry_1.HookRegistry();
                    yield transformHooksModule(globalTasksContext, registry);
                    return registry;
                }
                else {
                    const registry = new hook_registry_1.HookRegistry(transformHooksModule);
                    return registry;
                }
            }
            ;
            return Promise.resolve(new hook_registry_1.HookRegistry());
        });
    }
}
exports.NgPackagrBuilder = NgPackagrBuilder;
exports.default = NgPackagrBuilder;
//# sourceMappingURL=index.js.map