import { BuilderContext } from '@angular-devkit/architect';
import { TransformProvider } from 'ng-packagr/lib/brocc/transform.di';
import { EntryPointNode } from 'ng-packagr/lib/ng-v5/nodes';
import { NgPackagerHooks, NgPackagrBuilderTaskOptions, NgPackagrBuilderTaskSchema, TaskPhases, NormalizedNgPackagerHooks, NormalizedTaskPhases } from './hooks';
import { JobMetadata } from './job';
export declare const TRANSFORM_PROVIDER_MAP: Record<keyof NgPackagerHooks, TransformProvider>;
export declare const HOOK_PHASES: ("before" | "replace" | "after")[];
export declare function normalizeHooks(hooks: NgPackagerHooks): NormalizedNgPackagerHooks;
export declare function normalizeTaskPhases(taskPhases: TaskPhases<any>): NormalizedTaskPhases;
export declare function getTaskDataInput<T>(jobMeta: JobMetadata, tasks: NgPackagrBuilderTaskOptions<NgPackagrBuilderTaskSchema>): {
    [x: string]: any;
};
export declare function validateTypedTasks(jobs: JobMetadata[], context: BuilderContext, tasks: NgPackagrBuilderTaskOptions<NgPackagrBuilderTaskSchema>): Promise<void>;
export interface EntryPointStorage {
}
export declare const ENTRY_POINT_STORAGE: {
    ENTRY_POINT_DATA: WeakMap<EntryPointNode, EntryPointStorage>;
    get(node: EntryPointNode): EntryPointStorage;
    merge(node: EntryPointNode, data: Partial<EntryPointStorage>): void;
    delete(node: EntryPointNode): boolean;
};
//# sourceMappingURL=utils.d.ts.map