"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const operators_1 = require("rxjs/operators");
const core_1 = require("@angular-devkit/core");
const init_tsconfig_di_1 = require("ng-packagr/lib/ng-v5/init/init-tsconfig.di");
const analyse_sources_di_1 = require("ng-packagr/lib/ng-v5/init/analyse-sources.di");
const entry_point_di_1 = require("ng-packagr/lib/ng-v5/entry-point.di");
const compile_ngc_di_1 = require("ng-packagr/lib/ng-v5/entry-point/ts/compile-ngc.di");
const write_bundles_di_1 = require("ng-packagr/lib/ng-v5/entry-point/write-bundles.di");
const write_package_di_1 = require("ng-packagr/lib/ng-v5/entry-point/write-package.di");
exports.TRANSFORM_PROVIDER_MAP = {
    initTsConfig: init_tsconfig_di_1.INIT_TS_CONFIG_TRANSFORM,
    analyseSources: analyse_sources_di_1.ANALYSE_SOURCES_TRANSFORM,
    entryPoint: entry_point_di_1.ENTRY_POINT_TRANSFORM,
    compileNgc: compile_ngc_di_1.COMPILE_NGC_TRANSFORM,
    writeBundles: write_bundles_di_1.WRITE_BUNDLES_TRANSFORM,
    writePackage: write_package_di_1.WRITE_PACKAGE_TRANSFORM
};
exports.HOOK_PHASES = ['before', 'replace', 'after'];
function normalizeHooks(hooks) {
    const hookNames = Object.keys(exports.TRANSFORM_PROVIDER_MAP);
    for (const key of hookNames) {
        if (hooks[key]) {
            hooks[key] = normalizeTaskPhases(hooks[key]);
        }
    }
    return hooks;
}
exports.normalizeHooks = normalizeHooks;
function normalizeTaskPhases(taskPhases) {
    for (const phase of exports.HOOK_PHASES) {
        const taskOrTasksLike = taskPhases[phase];
        if (taskOrTasksLike) {
            taskPhases[phase] = Array.isArray(taskOrTasksLike)
                ? taskOrTasksLike
                : [taskOrTasksLike];
        }
    }
    return taskPhases;
}
exports.normalizeTaskPhases = normalizeTaskPhases;
function getTaskDataInput(jobMeta, tasks) {
    const data = tasks.data || {};
    return { [jobMeta.selector]: data[jobMeta.selector] };
}
exports.getTaskDataInput = getTaskDataInput;
function validateTypedTasks(jobs, context, tasks) {
    return __awaiter(this, void 0, void 0, function* () {
        const allHooksPromises = [];
        const promises = jobs.map(taskMeta => {
            return context.workspace.host.read(core_1.normalize(taskMeta.schema))
                .pipe(operators_1.map(buffer => core_1.virtualFs.fileBufferToString(buffer)), operators_1.map(str => core_1.parseJson(str, core_1.JsonParseMode.Loose)), operators_1.switchMap(jsonSchema => {
                return context.workspace.validateAgainstSchema(getTaskDataInput(taskMeta, tasks), jsonSchema);
            }))
                .toPromise();
        });
        allHooksPromises.push(...promises);
        yield Promise.all(allHooksPromises);
    });
}
exports.validateTypedTasks = validateTypedTasks;
// Used to mimic the `data` object in `EntryPointNode` so we can bind things to an entry point through the pipes
// external to ng-packager.
exports.ENTRY_POINT_STORAGE = {
    ENTRY_POINT_DATA: new WeakMap(),
    get(node) {
        return this.ENTRY_POINT_DATA.get(node);
    },
    merge(node, data) {
        const currentData = this.ENTRY_POINT_DATA.get(node) || {};
        Object.assign(currentData, data);
        this.ENTRY_POINT_DATA.set(node, currentData);
    },
    delete(node) {
        return this.ENTRY_POINT_DATA.delete(node);
    }
};
//# sourceMappingURL=utils.js.map